pro calc_noise_for_plot,sigmaimage_fc_1d,specimage_fc_p1_1d,specimage_fc_n1_1d,specimage_fc_0_1d,source_table,source_id,bg_nsum, $
                        error_p_wc_total,error_n_wc_total,error_p_wc_total_bg,error_n_wc_total_bg, $
                        shift_error_p_fc,shift_error_n_fc,error_p_fc_total,error_n_fc_total, $
                        no_wavelength_shift_error=no_wavelength_shift_error,three_sigma=three_sigma, $
                        apcor_fac=apcor_fac

  shift_error_p_fc=fltarr(!IRC_SPECRED_SPECEXTRACTPARAM.specaper_dy)
  shift_error_n_fc=fltarr(!IRC_SPECRED_SPECEXTRACTPARAM.specaper_dy)
 
  if defined(three_sigma) then sigma_factor=3. else sigma_factor=1.

  if keyword_set(no_wavelength_shift_error) then begin
     error_p_fc_total=sigmaimage_fc_1d[*,source_id]*sigma_factor
     error_n_fc_total=sigmaimage_fc_1d[*,source_id]*sigma_factor
  endif else begin
     for y=0,!IRC_SPECRED_SPECEXTRACTPARAM.specaper_dy-1 do begin
;       dy1=max([specimage_fc_p1_1d[(y-1)>0,source_id],specimage_fc_n1_1d[(y+1)<ymax,source_id],specimage_fc_1d[y,source_id]])
;       dy2=min([specimage_fc_p1_1d[(y-1)>0,source_id],specimage_fc_n1_1d[(y+1)<ymax,source_id],specimage_fc_1d[y,source_id]])
        dy1=max([specimage_fc_p1_1d[y,source_id],specimage_fc_n1_1d[y,source_id],specimage_fc_0_1d[y,source_id]])
        dy2=min([specimage_fc_p1_1d[y,source_id],specimage_fc_n1_1d[y,source_id],specimage_fc_0_1d[y,source_id]])
        
        shift_error_p_fc[y]=abs(dy1-specimage_fc_0_1d[y,source_id])
        shift_error_n_fc[y]=abs(dy2-specimage_fc_0_1d[y,source_id])
     endfor
     error_p_fc_total=sqrt(shift_error_p_fc^2.+sigmaimage_fc_1d[*,source_id]^2.)*sigma_factor
     error_n_fc_total=sqrt(shift_error_n_fc^2.+sigmaimage_fc_1d[*,source_id]^2.)*sigma_factor
    
  endelse

  if defined(apcor_fac) then begin
     error_p_fc_total/=apcor_fac
     error_n_fc_total/=apcor_fac
  endif

  error_p_wc_total=source_table[source_id].spec_bgnoise_1d_adu*sigma_factor
  error_n_wc_total=source_table[source_id].spec_bgnoise_1d_adu*sigma_factor
  error_p_wc_total_bg=source_table[source_id].spec_bgnoise_1d_adu/sqrt(bg_nsum*2.)*sigma_factor
  error_n_wc_total_bg=source_table[source_id].spec_bgnoise_1d_adu/sqrt(bg_nsum*2.)*sigma_factor


  if defined(apcor_fac) then begin
     error_p_wc_total/=apcor_fac
     error_n_wc_total/=apcor_fac
     error_p_wc_total_bg/=apcor_fac
     error_p_wc_total_bg/=apcor_fac
  endif

end
